package com.evernote.android.sample;

import java.util.ArrayList;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.ImageView;

public class ImageAdapter extends BaseAdapter {
  
  private Context c;
  private ArrayList<ImageResource> imageList;
  
  public ImageAdapter(Context c) {
    this(c, new ArrayList<ImageResource>());
  }

  public ImageAdapter(Context c, ArrayList<ImageResource> imageList) {
    this.c = c;
    this.imageList = imageList;
  }
  
  public void add(ImageResource resource) {
    this.imageList.add(resource);
  }

  @Override
  public int getCount() {
    return this.imageList.size();
  }

  @Override
  public Object getItem(int position) {
    return this.imageList.get(position);
  }

  @Override
  public long getItemId(int position) {
    return position;
  }

  @Override
  public View getView(int position, View convertView, ViewGroup parent) {
    ImageView imageView;
    
    if (convertView == null) {
      imageView = new ImageView(c);
      imageView.setLayoutParams(new GridView.LayoutParams(85, 85));
      imageView.setScaleType(ImageView.ScaleType.CENTER_CROP);
      imageView.setPadding(8, 8, 8, 8);
    } else {
      imageView = (ImageView) convertView;
    }
    imageView.setImageBitmap(this.imageList.get(position).getBitmap());
    return imageView;
  }
}
